import java.io.BufferedReader;
import java.io.IOException;
import java.util.Vector;

/** Classe responsvel por varrer um arquivo texto que contm os custos
 * de todas as cidades, devolvendo uma matriz de inteiros.
 * <BR><BR>
 * Trabalho de Algoritmos Genticos <BR> 
 * Disciplina de Inteligncia Artificial <BR>
 * Sistemas de Informao - 01/2009 <BR>
 * Professor: Guilherme Dhein <BR>
 * <BR>
 * @author Douglas Pasqualin
 * @author Reinaldo Dornelles
 *
 */
public class ParserArquivo 
{
	private BufferedReader arquivo;
	private int totalCidades;
	private int[][] custos;
	
	/**
	 * @param arquivo Arquivo texto onde esto os custos separados por espaos.
	 */
	public ParserArquivo(BufferedReader arquivo)
	{
		this.arquivo = arquivo;
	}
	
	public int getTotalCidades()
	{
		return this.totalCidades;
	}
	
	/**
	 * @return Custos que o parser identificou dentro do arquivo texto.
	 */
	public int[][] getCustos()
	{
		return this.custos;
	}
	
	/**
	 * Mtodo que varre um arquivo texto procurando todos os nmeros inteiros
	 * que contm no arquivo (separados por espao) e colocando os inteiros
	 * em uma matriz de custos.
	 */
	public void parser()
	{
		String linha = null;
		
		try 
		{
			linha = arquivo.readLine();
		} 
		catch (Exception e)
		{
			e.printStackTrace();
		}
		
		Vector<Integer> inteiros = new Vector<Integer>();

		String aux = "";
		for (int i=0; i<linha.length(); i++)
		{
			if (linha.charAt(i) != ' ')
			  aux += linha.charAt(i);
			else
			{
				inteiros.add(Integer.parseInt(aux));
				aux = "";
			}
		}
		
		totalCidades = inteiros.get(0); 
		custos = new int[totalCidades][totalCidades];
		
		int x = 1;
		for (int i = 0; i < totalCidades; i++)
			for (int j = 0; j < totalCidades; j++)
			{
				custos[i][j] = inteiros.get(x);
				x ++;
			}
		
		try 
		{
			arquivo.close();
		} 
		catch (IOException e) 
		{
			e.printStackTrace();
		}
		
	}

}
